//
// Delays with dsPIC30 TMR2
// Juha Niinikoski, OH2NLT 26.08.2005
//
//  MPLAB C30 compiler conversion, OH2GWE 2006.10.17
// 
//

// delay routines with TMR2

// microsecond delay
// max delay 2000us @ 120MHz sysclock

#include "juma-trx2.h"

void us_delay( unsigned int dly )
	{
	TMR2 = 0;					// reset timer
	PR2 = dly * DLYCONST;		// calculate delay
	IFS0bits.T2IF = 0;					// clear flags
	T2CONbits.TON = 1;					// start delay

	while(IFS0bits.T2IF == 0);			// wait here, do nothing
	
	T2CONbits.TON = 0;					// timer off and leave
	}

// millisecond delay
// max delay 65535ms
void ms_delay( unsigned int dly )
	{
	unsigned int x;
	for(x=0; x<dly; x++)
		{
		us_delay(1000);			// 1ms delay
		}
	}
